import _extends from 'babel-runtime/helpers/extends';
import RcCalendar from '../rc-components/calendar';
import YearCalendar from '../rc-components/calendar/YearCalendar';
import MonthCalendar from '../rc-components/calendar/MonthCalendar';
import createPicker from './createPicker';
import wrapPicker from './wrapPicker';
import RangePicker from './RangePicker';
import WeekPicker from './WeekPicker';
var DatePicker = wrapPicker(createPicker(RcCalendar));
var YearPicker = wrapPicker(createPicker(YearCalendar), 'YYYY');
var MonthPicker = wrapPicker(createPicker(MonthCalendar), 'YYYY-MM');
_extends(DatePicker, {
    RangePicker: wrapPicker(RangePicker),
    YearPicker: YearPicker,
    MonthPicker: MonthPicker,
    WeekPicker: wrapPicker(WeekPicker, 'gggg-wo')
});
export default DatePicker;