import * as React from 'react';
import Group from './Group';
import Search from './Search';
import TextArea from './TextArea';
import { Omit } from '../_util/type';
export declare type InputSelection = {
    start: number | null;
    end: number | null;
} | null;
export interface InputProps extends Omit<React.InputHTMLAttributes<HTMLInputElement>, 'size' | 'prefix'> {
    prefixCls?: string;
    size?: 'large' | 'default' | 'small';
    onPressEnter?: React.KeyboardEventHandler<HTMLInputElement>;
    addonBefore?: React.ReactNode;
    addonAfter?: React.ReactNode;
    prefix?: React.ReactNode;
    suffix?: React.ReactNode;
    typeCase?: 'upper' | 'lower';
    dbc2sbc?: boolean;
    trimAll?: boolean;
    trim?: boolean;
    inputChinese?: boolean;
}
export default class Input extends React.Component<InputProps, any> {
    static Group: typeof Group;
    static Search: typeof Search;
    static TextArea: typeof TextArea;
    static defaultProps: {
        prefixCls: string;
        type: string;
        disabled: boolean;
        dbc2sbc: boolean;
        trim: boolean;
        trimAll: boolean;
        inputChinese: boolean;
    };
    static propTypes: {
        type: any;
        id: any;
        size: any;
        maxLength: any;
        disabled: any;
        dbc2sbc: any;
        value: any;
        defaultValue: any;
        className: any;
        addonBefore: any;
        addonAfter: any;
        prefixCls: any;
        autosize: any;
        onPressEnter: any;
        onKeyDown: any;
        onKeyUp: any;
        onFocus: any;
        onBlur: any;
        prefix: any;
        suffix: any;
    };
    state: {
        type: string;
        showPassword: boolean;
    };
    input: HTMLInputElement;
    isOnComposition: boolean;
    inputSelection: InputSelection;
    componentDidMount(): void;
    componentDidUpdate(prevProps: InputProps): void;
    handleShowPassword: () => void;
    handleHidePassword: () => void;
    handleKeyDown: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    focus(): void;
    blur(): void;
    getInputClassName(): any;
    saveInput: (node: HTMLInputElement) => void;
    renderLabeledInput(children: React.ReactElement<any>): React.ReactElement<any>;
    renderLabeledIcon(children: React.ReactElement<any>): React.ReactElement<any>;
    handleComposition: (e: KeyboardEvent) => void;
    transformValue(v: any): any;
    handleBlur: (e: any) => void;
    handleChange: (e: any) => void;
    renderInput(): React.ReactElement<any>;
    render(): React.ReactElement<any>;
}
