import _toArray from 'babel-runtime/helpers/toArray';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
/**
 * @date 2019-01-21
 * @author WY yang.wang06@hang-china.com
 * @copyright HAND 2019
 */
import * as React from 'react';
import Menu from '../menu';
import Dropdown from '../dropdown';
import Icon from '../icon';
import Button from '../button';
import message from '../message';
import FilterDropdownMenuWrapper from './FilterDropdownMenuWrapper';
import ColumnFilterMenuItem from './ColumnFilterMenuItem';
import '../menu/style';
import '../dropdown';
import '../icon/style';
import '../button/style';
import '../message/style';
export function getColumnKey(column, index) {
    return column.key || column.dataIndex || index;
}
function getParentNode(triggerNode) {
    return triggerNode.parentNode;
}

var ColumnFilterMenu = function (_React$Component) {
    _inherits(ColumnFilterMenu, _React$Component);

    function ColumnFilterMenu(props) {
        _classCallCheck(this, ColumnFilterMenu);

        var _this = _possibleConstructorReturn(this, (ColumnFilterMenu.__proto__ || Object.getPrototypeOf(ColumnFilterMenu)).call(this, props));

        _this.items = {}; // 存储编辑的 column 的组件的 ref
        _this.handleEditChange = function (editing) {
            var prevCustomColumns = _this.state.prevCustomColumns;

            _this.setState({
                editing: editing,
                customColumns: prevCustomColumns
            });
        };
        // 渲染标题旁边的 icon
        _this.renderFilterIcon = function () {
            var locale = _this.props.locale;

            return React.createElement(Icon, { title: locale.filterTitle, className: 'custom-bars', type: 'bars' });
        };
        // 确认按钮点击
        _this.handleConfirmBtnClick = function () {
            var _this$props = _this.props,
                _this$props$columns = _this$props.columns,
                columns = _this$props$columns === undefined ? [] : _this$props$columns,
                confirmFilter = _this$props.confirmFilter,
                store = _this$props.store;

            var customColumnsGetPromise = [];
            columns.map(function (column, index) {
                return getColumnKey(column, index);
            }).forEach(function (key) {
                var columnFilterMenuItem = _this.items[key];
                if (columnFilterMenuItem) {
                    customColumnsGetPromise.push(columnFilterMenuItem.getValidateCustomColumn());
                }
            });
            Promise.all(customColumnsGetPromise).then(function (_ref) {
                var _ref2 = _toArray(_ref),
                    customColumns = _ref2.slice(0);

                _this.setState({
                    customColumns: customColumns,
                    editing: false
                });
                store.setState({ customColumns: customColumns });
                confirmFilter(customColumns);
            }, function (err) {
                message.error(err && err.message);
            });
        };
        // 获取编辑组件的 ref
        _this.handleItemRef = function (key, element) {
            _this.items[key] = element;
        };
        _this.state = {
            editing: false,
            customColumns: props.customColumns || [],
            prevCustomColumns: props.customColumns || []
        };
        return _this;
    }

    _createClass(ColumnFilterMenu, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                locale = _props.locale,
                prefixCls = _props.prefixCls,
                dropdownPrefixCls = _props.dropdownPrefixCls,
                getPopupContainer = _props.getPopupContainer;
            var editing = this.state.editing;

            var editTitle = this.renderEditTitle();
            var editContent = this.renderEditContent(); // this.renderMenus(columns)
            var menus = React.createElement(
                FilterDropdownMenuWrapper,
                { className: prefixCls + '-dropdown custom-column-dropdown' },
                React.createElement(
                    'div',
                    { className: dropdownPrefixCls + '-menu-item' },
                    editTitle
                ),
                React.createElement(
                    Menu,
                    { multiple: true, prefixCls: dropdownPrefixCls + '-menu', getPopupContainer: getParentNode },
                    editContent
                ),
                React.createElement(
                    'div',
                    { className: prefixCls + '-dropdown-btns' },
                    React.createElement(
                        Button,
                        { size: 'small', className: prefixCls + '-dropdown-link confirm', onClick: this.handleConfirmBtnClick },
                        locale.filterConfirm
                    )
                )
            );
            return React.createElement(
                Dropdown,
                { trigger: ['click'], overlay: menus, visible: editing, onVisibleChange: this.handleEditChange, getPopupContainer: getPopupContainer, forceRender: true },
                this.renderFilterIcon()
            );
        }
        // modified by yang.wang06@hand-china.com

    }, {
        key: 'renderEditItem',
        value: function renderEditItem(column, index) {
            var _this2 = this;

            var customColumns = this.state.customColumns;

            var key = getColumnKey(column);
            var customColumn = customColumns.find(function (fCustomColumn) {
                return fCustomColumn.fieldKey === key;
            });
            return React.createElement(
                Menu.Item,
                { key: key },
                React.createElement(ColumnFilterMenuItem, { customColumn: customColumn, column: column, index: index, ref: function ref(item) {
                        return _this2.handleItemRef(key, item);
                    } })
            );
        }
        // 渲染编辑的标题
        // modified by yang.wang06@hand-china.com

    }, {
        key: 'renderEditTitle',
        value: function renderEditTitle() {
            var filterBarLocale = this.props.filterBarLocale;

            var _ref3 = filterBarLocale || {},
                display = _ref3.display,
                field = _ref3.field,
                fixedLeft = _ref3.fixedLeft,
                orderSeq = _ref3.orderSeq;

            return React.createElement(
                'div',
                null,
                React.createElement(
                    'div',
                    { className: 'dropdown-menu-text' },
                    display
                ),
                React.createElement(
                    'div',
                    { className: 'dropdown-menu-text' },
                    field
                ),
                React.createElement(
                    'div',
                    { className: 'dropdown-menu-text' },
                    fixedLeft
                ),
                React.createElement(
                    'div',
                    { className: 'dropdown-menu-text' },
                    orderSeq
                )
            );
        }
        // 渲染编辑区域内容

    }, {
        key: 'renderEditContent',
        value: function renderEditContent() {
            var _this3 = this;

            var _props$columns = this.props.columns,
                columns = _props$columns === undefined ? [] : _props$columns;

            return columns.map(function (column, index) {
                return _this3.renderEditItem(column, index);
            });
        }
    }], [{
        key: 'getDerivedStateFromProps',
        value: function getDerivedStateFromProps(nextProps, prevState) {
            var customColumns = nextProps.customColumns;
            var prevCustomColumns = prevState.prevCustomColumns;

            if (customColumns && customColumns !== prevCustomColumns) {
                return {
                    customColumns: customColumns,
                    prevCustomColumns: customColumns
                };
            }
            return null;
        }
    }]);

    return ColumnFilterMenu;
}(React.Component);

export default ColumnFilterMenu;