import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _extends from 'babel-runtime/helpers/extends';
/**
 * @date 2019-01-21
 * @author
 */
import * as React from 'react';
import Checkbox from '../checkbox';
import InputNumber from '../input-number';
import { getColumnKey } from './ColumnFilterMenu';
// 引入组件后 还需引入对应的样式
import '../input-number/style';
import '../checkbox/style';
// 将 render 中 不会改变的变量提取出来 modified by yang.wang06@hand-china.com
var sortInputStyle = {
    width: '60px'
};
var sortInputWrapStyle = _extends({}, sortInputStyle, { display: 'inline-block' });
var sortInputWrapStyleCenter = _extends({}, sortInputWrapStyle, { textAlign: 'center' });

var ColumnFilterMenuItem = function (_React$Component) {
    _inherits(ColumnFilterMenuItem, _React$Component);

    function ColumnFilterMenuItem(props) {
        _classCallCheck(this, ColumnFilterMenuItem);

        // 修改是否 lock (fixedLeft)
        var _this = _possibleConstructorReturn(this, (ColumnFilterMenuItem.__proto__ || Object.getPrototypeOf(ColumnFilterMenuItem)).call(this, props));

        _this.handleFixedLeftChange = function (e) {
            var customColumn = _this.state.customColumn;

            var fixedLeft = e.target.checked ? 1 : 0;
            _this.setState({
                customColumn: _extends({}, customColumn, { fixedLeft: fixedLeft, fixedRight: fixedLeft === 1 ? 0 : customColumn.fixedRight })
            });
        };
        // // 修改 fixedRight
        // handleFixedRightChange = (e: CheckboxChangeEvent) => {
        //   const { customColumn } = this.state;
        //   const fixedRight = e.target.checked ? 1 : 0;
        //   this.setState({
        //     customColumn: {
        //       ...customColumn,
        //       fixedRight,
        //       fixedLeft: (fixedLeft === 1) ? 0 : customColumn.fixedLeft, // 如果 fixedRight 为 1,则 fixedLeft 为 0
        //     },
        //   });
        // }
        // 修改是否隐藏
        _this.handleHiddenChange = function (e) {
            var customColumn = _this.state.customColumn;

            var hidden = e.target.checked ? 0 : 1;
            _this.setState({
                customColumn: _extends({}, customColumn, { hidden: hidden })
            });
        };
        // 修改排序
        _this.handleOrderSeqChange = function (value) {
            var customColumn = _this.state.customColumn;

            _this.setState({
                customColumn: _extends({}, customColumn, { orderSeq: value })
            });
        };
        // 获取校验的数据
        _this.getValidateCustomColumn = function () {
            var customColumn = _this.state.customColumn;

            return Promise.resolve(customColumn);
        };
        var customColumn = props.customColumn || {
            hidden: 0,
            fixedLeft: 0,
            fixedRight: 0,
            orderSeq: props.index,
            fieldKey: getColumnKey(props.column, props.index)
        };
        _this.state = {
            customColumn: customColumn,
            prevCustomColumn: customColumn
        };
        return _this;
    }

    _createClass(ColumnFilterMenuItem, [{
        key: 'render',
        value: function render() {
            var column = this.props.column;
            var customColumn = this.state.customColumn;
            // <div
            //   style={sortInputWrapStyleCenter}
            // >
            //   <Checkbox
            //     name="fixedRight"
            //     checked={customColumn.fixedRight === 1}
            //     onChange={this.handleFixedRightChange}
            //     checkedValue={1}
            //     unCheckedValue={0}
            //   />
            // </div>

            return React.createElement(
                React.Fragment,
                null,
                React.createElement(
                    'div',
                    { style: sortInputWrapStyleCenter },
                    React.createElement(Checkbox, { style: sortInputStyle, checked: customColumn.hidden !== 1, onChange: this.handleHiddenChange })
                ),
                React.createElement(
                    'div',
                    { className: 'dropdown-menu-text' },
                    column.title
                ),
                React.createElement(
                    'div',
                    { style: sortInputWrapStyleCenter },
                    React.createElement(Checkbox, { name: 'fixedLeft', checked: customColumn.fixedLeft === 1, onChange: this.handleFixedLeftChange })
                ),
                React.createElement(
                    'div',
                    { style: sortInputWrapStyle },
                    React.createElement(InputNumber, { name: 'orderSeq', style: sortInputStyle, min: 0, step: 1, precision: 0, value: customColumn.orderSeq, onChange: this.handleOrderSeqChange })
                )
            );
        }
    }], [{
        key: 'getDerivedStateFromProps',
        value: function getDerivedStateFromProps(nextProps, prevState) {
            var customColumn = nextProps.customColumn;
            var prevCustomColumn = prevState.prevCustomColumn;

            if (customColumn && prevCustomColumn !== customColumn) {
                return {
                    customColumn: customColumn,
                    prevCustomColumn: customColumn
                };
            }
            return null;
        }
    }]);

    return ColumnFilterMenuItem;
}(React.Component);

export default ColumnFilterMenuItem;