import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _extends from 'babel-runtime/helpers/extends';
var __rest = this && this.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};
import * as React from 'react';
import Draggable from 'react-draggable';
function cloneElement(element, props) {
    if (props.style && element.props.style) {
        props.style = _extends({}, element.props.style, props.style);
    }
    if (props.className && element.props.className) {
        props.className = element.props.className + ' ' + props.className;
    }
    return React.cloneElement(element, props);
}

var Resizable = function (_React$Component) {
    _inherits(Resizable, _React$Component);

    function Resizable() {
        _classCallCheck(this, Resizable);

        var _this = _possibleConstructorReturn(this, (Resizable.__proto__ || Object.getPrototypeOf(Resizable)).apply(this, arguments));

        _this.handleDrag = function (event) {
            event.stopPropagation();
            event.preventDefault();
        };
        _this.saveDraggable = function (draggable) {
            _this.draggable = draggable;
        };
        _this.handleStop = function (event, dragCallbackData) {
            var onResize = _this.props.onResize;

            if (onResize) {
                onResize(event, dragCallbackData);
            }
            if (_this.draggable) {
                _this.draggable.setState({ x: 0, y: 0 });
            }
        };
        return _this;
    }

    _createClass(Resizable, [{
        key: 'render',
        value: function render() {
            // eslint-disable-next-line no-unused-vars
            var _a = this.props,
                children = _a.children,
                p = __rest(_a, ["children"]);
            var className = p.className ? p.className + ' react-resizable' : 'react-resizable';
            var subchildren = children.props.children;
            // What we're doing here is getting the child of this element, and cloning it with this element's props.
            // We are then defining its children as:
            // Its original children (resizable's child's children), and
            // A draggable handle.

            return cloneElement(children, {
                className: className,
                children: [subchildren, React.createElement(
                    Draggable,
                    { ref: this.saveDraggable, axis: 'x', key: 'resizableHandle', onDrag: this.handleDrag, onStop: this.handleStop },
                    React.createElement('span', { className: 'column-resizable-handle' })
                )]
            });
        }
    }]);

    return Resizable;
}(React.Component);

export default Resizable;