import _typeof from 'babel-runtime/helpers/typeof';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _extends from 'babel-runtime/helpers/extends';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
var __rest = this && this.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import Resizable from './Resizable';
import RcTable from '../rc-components/table';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import Pagination from '../pagination';
import Icon from '../icon';
import Spin from '../spin';
import LocaleReceiver from '../locale-provider/LocaleReceiver';
import defaultLocale from '../locale-provider/default';
import warning from '../_util/warning';
import FilterDropdown from './filterDropdown';
import createStore from './createStore';
import SelectionBox from './SelectionBox';
import SelectionCheckboxAll from './SelectionCheckboxAll';
import Column from './Column';
import Button from '../button';
import ColumnGroup from './ColumnGroup';
import createBodyRow from './createBodyRow';
import { flatArray, treeMap, flatFilter, getHeight, normalizeColumns, TableRowContext, isNumber } from './util';
import ColumnFilterMenu from './ColumnFilterMenu';
import { ConfigConsumer } from '../config-provider';
function noop() {}
// modified by njq.niu@hand-china.com
var ResizeableTitle = function ResizeableTitle(props) {
    var onResize = props.onResize,
        onDrag = props.onDrag,
        width = props.width,
        restProps = __rest(props, ["onResize", "onDrag", "width"]);

    if (!width) {
        return React.createElement('th', restProps);
    }
    return React.createElement(
        Resizable,
        { onResize: onResize, onDrag: onDrag },
        React.createElement('th', restProps)
    );
};
function stopPropagation(e) {
    e.stopPropagation();
    if (e.nativeEvent.stopImmediatePropagation) {
        e.nativeEvent.stopImmediatePropagation();
    }
}
function getRowSelection(props) {
    return props.rowSelection || {};
}
var defaultPagination = {
    onChange: noop,
    onShowSizeChange: noop
};
/**
 * Avoid creating new object, so that parent component's shouldComponentUpdate
 * can works appropriately。
 */
var emptyObject = {};

var Table = function (_React$Component) {
    _inherits(Table, _React$Component);

    function Table(props) {
        _classCallCheck(this, Table);

        var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

        _this.setElementRef = function (node) {
            if (node && node['tableContent']) {
                _this.element = node['tableContent'];
            }
        };
        _this.setWapperRef = function (node) {
            _this.wrapper = node;
        };
        _this.getCheckboxPropsByItem = function (item, index) {
            var rowSelection = getRowSelection(_this.props);
            if (!rowSelection.getCheckboxProps) {
                return {};
            }
            var key = _this.getRecordKey(item, index);
            // Cache checkboxProps
            if (!_this.CheckboxPropsCache[key]) {
                _this.CheckboxPropsCache[key] = rowSelection.getCheckboxProps(item);
            }
            return _this.CheckboxPropsCache[key];
        };
        _this.onRow = function (record, index) {
            var _this$props = _this.props,
                onRow = _this$props.onRow,
                prefixCls = _this$props.prefixCls;

            var custom = onRow ? onRow(record, index) : {};
            return _extends({}, custom, { prefixCls: prefixCls, store: _this.store, rowKey: _this.getRecordKey(record, index) });
        };
        _this.handleFilter = function (column, nextFilters) {
            var props = _this.props;
            var pagination = _extends({}, _this.state.pagination);
            var filters = _extends({}, _this.state.filters, _defineProperty({}, _this.getColumnKey(column), nextFilters));
            // Remove filters not in current columns
            var currentColumnKeys = [];
            treeMap(_this.columns, function (c) {
                if (!c.children) {
                    currentColumnKeys.push(_this.getColumnKey(c));
                }
            });
            Object.keys(filters).forEach(function (columnKey) {
                if (currentColumnKeys.indexOf(columnKey) < 0) {
                    delete filters[columnKey];
                }
            });
            if (props.pagination) {
                // Reset current prop
                pagination.current = 1;
                pagination.onChange(pagination.current);
            }
            var newState = {
                pagination: pagination,
                filters: {}
            };
            var filtersToSetState = _extends({}, filters);
            // Remove filters which is controlled
            _this.getFilteredValueColumns().forEach(function (col) {
                var columnKey = _this.getColumnKey(col);
                if (columnKey) {
                    delete filtersToSetState[columnKey];
                }
            });
            if (Object.keys(filtersToSetState).length > 0) {
                newState.filters = filtersToSetState;
            }
            // Controlled current prop will not respond user interaction
            if (_typeof(props.pagination) === 'object' && 'current' in props.pagination) {
                newState.pagination = _extends({}, pagination, { current: _this.state.pagination.current });
            }
            _this.setState(newState, function () {
                _this.store.setState({
                    selectionDirty: false
                });
                var onChange = _this.props.onChange;
                if (onChange) {
                    onChange.apply(null, _this.prepareParamsArguments(_extends({}, _this.state, { selectionDirty: false, filters: filters,
                        pagination: pagination })));
                }
            });
        };
        _this.handleSelect = function (record, rowIndex, e) {
            var checked = e.target.checked;
            var nativeEvent = e.nativeEvent;
            var defaultSelection = _this.store.getState().selectionDirty ? [] : _this.getDefaultSelection();
            var selectedRowKeys = _this.store.getState().selectedRowKeys.concat(defaultSelection);
            var key = _this.getRecordKey(record, rowIndex);
            if (checked) {
                selectedRowKeys.push(_this.getRecordKey(record, rowIndex));
            } else {
                selectedRowKeys = selectedRowKeys.filter(function (i) {
                    return key !== i;
                });
            }
            _this.store.setState({
                selectionDirty: true
            });
            _this.setSelectedRowKeys(selectedRowKeys, {
                selectWay: 'onSelect',
                record: record,
                checked: checked,
                changeRowKeys: void 0,
                nativeEvent: nativeEvent
            });
        };
        _this.handleRadioSelect = function (record, rowIndex, e) {
            var checked = e.target.checked;
            var nativeEvent = e.nativeEvent;
            var defaultSelection = _this.store.getState().selectionDirty ? [] : _this.getDefaultSelection();
            var selectedRowKeys = _this.store.getState().selectedRowKeys.concat(defaultSelection);
            var key = _this.getRecordKey(record, rowIndex);
            selectedRowKeys = [key];
            _this.store.setState({
                selectionDirty: true
            });
            _this.setSelectedRowKeys(selectedRowKeys, {
                selectWay: 'onSelect',
                record: record,
                checked: checked,
                changeRowKeys: void 0,
                nativeEvent: nativeEvent
            });
        };
        _this.handleSelectRow = function (selectionKey, index, onSelectFunc) {
            var data = _this.getFlatCurrentPageData();
            var defaultSelection = _this.store.getState().selectionDirty ? [] : _this.getDefaultSelection();
            var selectedRowKeys = _this.store.getState().selectedRowKeys.concat(defaultSelection);
            var changeableRowKeys = data.filter(function (item, i) {
                return !_this.getCheckboxPropsByItem(item, i).disabled;
            }).map(function (item, i) {
                return _this.getRecordKey(item, i);
            });
            var changeRowKeys = [];
            var selectWay = 'onSelectAll';
            var checked = void 0;
            // handle default selection
            switch (selectionKey) {
                case 'all':
                    changeableRowKeys.forEach(function (key) {
                        if (selectedRowKeys.indexOf(key) < 0) {
                            selectedRowKeys.push(key);
                            changeRowKeys.push(key);
                        }
                    });
                    selectWay = 'onSelectAll';
                    checked = true;
                    break;
                case 'removeAll':
                    changeableRowKeys.forEach(function (key) {
                        if (selectedRowKeys.indexOf(key) >= 0) {
                            selectedRowKeys.splice(selectedRowKeys.indexOf(key), 1);
                            changeRowKeys.push(key);
                        }
                    });
                    selectWay = 'onSelectAll';
                    checked = false;
                    break;
                case 'invert':
                    changeableRowKeys.forEach(function (key) {
                        if (selectedRowKeys.indexOf(key) < 0) {
                            selectedRowKeys.push(key);
                        } else {
                            selectedRowKeys.splice(selectedRowKeys.indexOf(key), 1);
                        }
                        changeRowKeys.push(key);
                        selectWay = 'onSelectInvert';
                    });
                    break;
                default:
                    break;
            }
            _this.store.setState({
                selectionDirty: true
            });
            // when select custom selection, callback selections[n].onSelect
            var rowSelection = _this.props.rowSelection;

            var customSelectionStartIndex = 2;
            if (rowSelection && rowSelection.hideDefaultSelections) {
                customSelectionStartIndex = 0;
            }
            if (index >= customSelectionStartIndex && typeof onSelectFunc === 'function') {
                return onSelectFunc(changeableRowKeys);
            }
            _this.setSelectedRowKeys(selectedRowKeys, {
                selectWay: selectWay,
                checked: checked,
                changeRowKeys: changeRowKeys
            });
        };
        _this.handlePageChange = function (current) {
            for (var _len = arguments.length, otherArguments = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                otherArguments[_key - 1] = arguments[_key];
            }

            var props = _this.props;
            var pagination = _extends({}, _this.state.pagination);
            if (current) {
                pagination.current = current;
            } else {
                pagination.current = pagination.current || 1;
            }
            pagination.onChange.apply(pagination, [pagination.current].concat(otherArguments));
            var newState = {
                pagination: pagination
            };
            // Controlled current prop will not respond user interaction
            if (props.pagination && _typeof(props.pagination) === 'object' && 'current' in props.pagination) {
                newState.pagination = _extends({}, pagination, { current: _this.state.pagination.current });
            }
            _this.setState(newState);
            _this.store.setState({
                selectionDirty: false
            });
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange.apply(null, _this.prepareParamsArguments(_extends({}, _this.state, { selectionDirty: false, pagination: pagination })));
            }
        };
        _this.renderSelectionBox = function (type) {
            return function (_, record, index) {
                var rowIndex = _this.getRecordKey(record, index); // 从 1 开始
                var props = _this.getCheckboxPropsByItem(record, index);
                var handleChange = function handleChange(e) {
                    type === 'radio' ? _this.handleRadioSelect(record, rowIndex, e) : _this.handleSelect(record, rowIndex, e);
                };
                return React.createElement(
                    'span',
                    { onClick: stopPropagation },
                    React.createElement(SelectionBox, _extends({ type: type, store: _this.store, rowIndex: rowIndex, onChange: handleChange, defaultSelection: _this.getDefaultSelection() }, props))
                );
            };
        };
        _this.getRecordKey = function (record, index) {
            var rowKey = _this.props.rowKey;
            var recordKey = typeof rowKey === 'function' ? rowKey(record, index) : record[rowKey];
            warning(recordKey !== undefined, 'Each record in dataSource of table should have a unique `key` prop, ' + 'or set `rowKey` of Table to an unique primary key, ' + 'see https://u.ant.design/table-row-key');
            return recordKey === undefined ? index : recordKey;
        };
        _this.getPopupContainer = function () {
            return ReactDOM.findDOMNode(_this);
        };
        // 根据 customColumns 返回新的 columns
        // modified by yang.wang06@hand-china.com
        _this.renderCustomColumns = function (columns) {
            var customColumns = _this.getCustomColumns() || [];
            if (customColumns.length === 0) {
                return columns.map(function (column, colIndex) {
                    return _extends({}, column, { orderSeq: colIndex });
                });
            } else {
                var newColumns = [];

                var _loop = function _loop(colIndex) {
                    var column = columns[colIndex];
                    var customColumn = customColumns.find(function (fCustomColumn) {
                        return fCustomColumn.fieldKey === _this.getColumnKey(column);
                    });
                    if (!customColumn) {
                        // 该字段没有自定义, 将排序设置为默认的顺序, 继续
                        newColumns.push(_extends({}, column, { orderSeq: colIndex }));
                        return 'continue';
                    }
                    if (customColumn.hidden === 1) {
                        // 该字段隐藏了 不需要显示, 继续
                        return 'continue';
                    }
                    var newColumn = _extends({}, column);
                    if (customColumn.fixedLeft === 1) {
                        newColumn.fixed = 'left';
                    }
                    // else if (customColumn.fixedRight) {
                    //   newColumn.fixed = 'right';
                    // }
                    newColumn.orderSeq = customColumn.orderSeq === undefined ? colIndex : customColumn.orderSeq;
                    newColumns.push(newColumn);
                };

                for (var colIndex = 0; colIndex < columns.length; colIndex++) {
                    var _ret = _loop(colIndex);

                    if (_ret === 'continue') continue;
                }
                var noFixedColumns = [];
                var fixedLeftColumns = [];
                var fixedRightColumns = [];
                var actionColumns = newColumns.length === 0 ? [] : [newColumns[newColumns.length - 1]];
                for (var colIndex = 0; colIndex < newColumns.length - 1; colIndex += 1) {
                    var _column = newColumns[colIndex];
                    if (_column.fixed) {
                        if (_column.fixed === 'left') {
                            fixedLeftColumns.push(_column);
                        } else if (_column.fixed === 'right') {
                            fixedRightColumns.push(_column);
                        } else {
                            noFixedColumns.push(_column);
                        }
                    } else {
                        noFixedColumns.push(_column);
                    }
                }
                fixedLeftColumns.sort(function (a, b) {
                    return a.orderSeq - b.orderSeq;
                });
                noFixedColumns.sort(function (a, b) {
                    return a.orderSeq - b.orderSeq;
                });
                return [].concat(fixedLeftColumns, noFixedColumns, fixedRightColumns, actionColumns);
            }
        };
        /**
         * 获取用户个性化的 Table 的 头设置
         * table's columns
         */
        _this.getCustomColumns = function () {
            var _this$props2 = _this.props,
                customColumns = _this$props2.customColumns,
                defaultCustomColumns = _this$props2.defaultCustomColumns,
                onCustomColumnFilter = _this$props2.onCustomColumnFilter;

            if (customColumns) {
                if (defaultCustomColumns) {
                    throw new Error('Table Can\'t set customColumns and defaultCustomColumns together');
                }
                if (!onCustomColumnFilter) {
                    throw new Error('Table must set customColumns and onCustomColumnFilter together');
                }
            }
            if (customColumns) {
                return customColumns;
            } else if (defaultCustomColumns) {
                var _this$state$customCol = _this.state.customColumns,
                    stateCustomColumns = _this$state$customCol === undefined ? defaultCustomColumns : _this$state$customCol;

                return stateCustomColumns;
            }
        };
        /**
         * 用户个性化 Table 编辑
         */
        _this.handleCustomColumnFilter = function () {
            var onCustomColumnFilter = _this.props.onCustomColumnFilter;

            var _this$store$getState = _this.store.getState(),
                _this$store$getState$ = _this$store$getState.customColumns,
                customColumns = _this$store$getState$ === undefined ? [] : _this$store$getState$;

            _this.setCustomState(customColumns);
            if (onCustomColumnFilter) {
                onCustomColumnFilter(customColumns);
            }
        };
        _this.handleShowSizeChange = function (current, pageSize) {
            var pagination = _this.state.pagination;
            pagination.onShowSizeChange(current, pageSize);
            var nextPagination = _extends({}, pagination, { pageSize: pageSize,
                current: current });
            _this.setState({ pagination: nextPagination });
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange.apply(null, _this.prepareParamsArguments(_extends({}, _this.state, { pagination: nextPagination })));
            }
        };
        // modified by njq.niu@hand-china.com
        _this.handleResize = function (col) {
            return function (_, dragCallbackData) {
                var columnAdjust = _this.state.columnAdjust;

                var index = -1;
                for (var i = 0; i < _this.columns.length; i++) {
                    if (_this.columns[i].key === col.key || _this.columns[i].dataIndex === col.dataIndex) {
                        index = i;
                    }
                }
                var width = _this.columns[index].width + dragCallbackData.x;
                if (index !== -1) {
                    var key = _this.columns[index].dataIndex;
                    /**
                     * 使用以前存储的拖动的宽度值
                     */
                    if (columnAdjust && key && columnAdjust[key] && typeof columnAdjust[key] === "number" && columnAdjust[key] >= 50) {
                        width = columnAdjust[key] + dragCallbackData.x;
                    }
                    if (width <= 50) {
                        width = 50;
                    }
                    _this.columns[index] = _extends({}, _this.columns[index], { width: width });
                    if (key) {
                        columnAdjust[key] = width;
                    }
                    _this.setState({
                        columnAdjust: columnAdjust
                    });
                }
            };
        };
        _this.getContentHeight = function () {
            var wrapper = _this.wrapper,
                element = _this.element,
                autoHeight = _this.props.autoHeight;

            if (autoHeight && wrapper && wrapper.parentNode) {
                var _wrapper$parentNode$g = wrapper.parentNode.getBoundingClientRect(),
                    parentTop = _wrapper$parentNode$g.top,
                    parentHeight = _wrapper$parentNode$g.height;

                var _element$getBoundingC = element.getBoundingClientRect(),
                    tableTop = _element$getBoundingC.top;

                var diff = 80;
                if (autoHeight && autoHeight !== true && isNumber(autoHeight.diff)) {
                    diff = autoHeight.diff || 80;
                }
                if (wrapper) {
                    return parentHeight - (tableTop - parentTop) - diff || 0;
                }
            }
            return 0;
        };
        _this.syncSize = function () {
            var element = _this.element;

            if (element) {
                var prefixCls = _this.props.prefixCls;

                var height = _this.getContentHeight();
                if (element && isNumber(height)) {
                    var tableTitle = element.querySelector('.' + prefixCls + '-title');
                    var tableHeader = element.querySelector('.' + prefixCls + '-thead');
                    var tableFooter = element.querySelector('.' + prefixCls + '-footer');
                    var tableFootWrap = element.querySelector('.' + prefixCls + '-foot');
                    if (tableTitle) {
                        height -= getHeight(tableTitle);
                    }
                    if (tableHeader) {
                        height -= getHeight(tableHeader);
                    }
                    if (tableFooter) {
                        height -= getHeight(tableFooter);
                    }
                    if (tableFootWrap) {
                        height -= getHeight(tableFootWrap);
                    }
                    return height;
                }
            }
            return 0;
        };
        _this.renderTable = function (contextLocale, loading) {
            var _classNames;

            var locale = _extends({}, contextLocale, _this.props.locale);
            var _a = _this.props,
                style = _a.style,
                autoHeight = _a.autoHeight,
                className = _a.className,
                tableBodyStyle = _a.bodyStyle,
                prefixCls = _a.prefixCls,
                showHeader = _a.showHeader,
                resizable = _a.resizable,
                restProps = __rest(_a, ["style", "autoHeight", "className", "bodyStyle", "prefixCls", "showHeader", "resizable"]);
            var data = _this.getCurrentPageData();
            var expandIconAsCell = _this.props.expandedRowRender && _this.props.expandIconAsCell !== false;
            var tableAutoHeight = _this.state.tableAutoHeight;

            var bodyStyle = _extends({}, tableBodyStyle);
            if (tableAutoHeight && tableAutoHeight > 0 && autoHeight) {
                if (autoHeight !== true && autoHeight.type === "maxHeight" /* maxHeight */) {
                        bodyStyle = _extends({}, bodyStyle, { maxHeight: tableAutoHeight });
                    } else {
                    bodyStyle = _extends({}, bodyStyle, { height: tableAutoHeight });
                }
            }
            var classString = classNames((_classNames = {}, _defineProperty(_classNames, prefixCls + '-' + _this.props.size, true), _defineProperty(_classNames, prefixCls + '-bordered', _this.props.bordered), _defineProperty(_classNames, prefixCls + '-empty', !data.length), _defineProperty(_classNames, prefixCls + '-without-column-header', !showHeader), _defineProperty(_classNames, 'resizable-table', resizable), _classNames));
            var columns = _this.columns.concat(); // 为了不更改原先的 columns
            columns = _this.renderColumnsDropdown(columns, locale);
            // 先执行: renderColumnsDropDown, 可能会更改 columns 的 fixed 或者 数量
            columns = _this.renderCustomColumns(columns);
            // 改变了 columns, 依赖于 columns 的 fixed: left;
            columns = _this.renderRowSelection(columns, locale);
            columns = columns.map(function (column, i) {
                var newColumn = _extends({}, column);
                newColumn.key = _this.getColumnKey(newColumn, i);
                return newColumn;
            });
            var expandIconColumnIndex = columns[0] && columns[0].key === 'selection-column' ? 1 : 0;
            if ('expandIconColumnIndex' in restProps) {
                expandIconColumnIndex = restProps.expandIconColumnIndex;
            }
            // modified by njq.niu@hand-china.com
            if (resizable) {
                var _this$state$columnAdj = _this.state.columnAdjust,
                    columnAdjust = _this$state$columnAdj === undefined ? {} : _this$state$columnAdj;

                var keys = Object.keys(columnAdjust);
                columns = columns.map(function (col) {
                    var otherProp = {};
                    var colWidth = col.width;
                    if (typeof colWidth === 'number') {
                        var key = col.dataIndex;
                        if (key && keys.indexOf(key) !== -1) {
                            otherProp.width = columnAdjust[key];
                        }
                    }
                    return _extends({}, col, otherProp, { onCell: function onCell(record) {
                            var cellProps = {};
                            if (col.onCell) {
                                cellProps = col.onCell(record) || {};
                            }
                            cellProps = _extends({}, cellProps, { style: _extends({}, cellProps.style || {}, { maxWidth: col.width, minWidth: col.width }) });
                            return cellProps;
                        }, onHeaderCell: function onHeaderCell(column) {
                            var headerCellProps = {};
                            if (col.onHeaderCell) {
                                headerCellProps = col.onHeaderCell(column) || {};
                            }
                            headerCellProps = _extends({}, headerCellProps, { width: column.width, style: _extends({}, headerCellProps.style || {}, { maxWidth: col.width, minWidth: col.width }), onResize: _this.handleResize(col) });
                            return headerCellProps;
                        } });
                });
            }
            return React.createElement(
                React.Fragment,
                null,
                React.createElement(
                    ConfigConsumer,
                    null,
                    _this.renderConfigConsumer()
                ),
                React.createElement(RcTable, _extends({ key: 'table' }, restProps, { ref: _this.setElementRef, resizable: resizable, onRow: _this.onRow, components: _this.components, prefixCls: prefixCls, data: data, bodyStyle: bodyStyle, columns: columns, showHeader: showHeader, className: classString, expandIconColumnIndex: expandIconColumnIndex, expandIconAsCell: expandIconAsCell, emptyText: !loading.spinning && locale.emptyText }))
            );
        };
        _this.renderExportButton = function (props) {
            var dataParam = props.dataParam,
                method = props.method,
                action = props.action,
                onClick = props.onClick;

            _this.store.setState({ exportStoreProps: props });
            if (!dataParam) {
                dataParam = {};
            }
            if (!method) {
                method = 'get';
            }
            if (!action) {
                action = '';
            }
            var exportProps = {
                dataParam: dataParam,
                method: method,
                action: action
            };
            onClick = function onClick() {
                _this.handleExport(exportProps);
            };
            return (
                // @ts-ignore
                React.createElement(Button, _extends({ type: 'primary', disabled: _this.store.getState().exported, loading: _this.store.getState().exported }, props, { onClick: onClick }))
            );
        };
        _this.handleExport = function (exportedProps) {
            var dataParam = exportedProps.dataParam,
                method = exportedProps.method,
                action = exportedProps.action;
            var iframe = _this.iframe;

            var exportStoreProps = _this.store.getState().exportStoreProps;
            if (exportStoreProps && exportStoreProps.onClick && typeof exportStoreProps.onClick === 'function') {
                exportStoreProps.onClick(exportedProps);
            } else {
                if (!iframe) {
                    iframe = document.createElement('iframe');
                    iframe.id = '_export_window';
                    iframe.name = '_export_window';
                    iframe.style.cssText = 'position:absolute;left:-10000px;top:-10000px;width:1px;height:1px;display:none';
                    document.body.appendChild(iframe);
                }
                _this.store.setState({ exported: true });
                var form = document.createElement('form');
                form.target = '_export_window';
                form.method = method;
                form.action = action;
                var s = document.createElement('input');
                s.id = '_request_data';
                s.type = 'hidden';
                s.name = '_request_data';
                s.value = JSON.stringify(dataParam);
                form.appendChild(s);
                document.body.appendChild(form);
                form.submit();
                document.body.removeChild(form);
                _this.store.setState({ exported: false });
            }
        };
        warning(!('columnsPageRange' in props || 'columnsPageSize' in props), '`columnsPageRange` and `columnsPageSize` are removed, please use ' + 'fixed columns instead, see: https://u.ant.design/fixed-columns.');
        _this.columns = props.columns || normalizeColumns(props.children);
        _this.createComponents(props.components);
        _this.state = _extends({}, _this.getDefaultSortOrder(_this.columns), {
            // 减少状态
            filters: _this.getFiltersFromColumns(), pagination: _this.getDefaultPagination(props),
            // modified by njq.niu@hand-china.com
            columnAdjust: {}, customColumns: _this.getCustomColumns() || [], tableAutoHeight: 0 });
        _this.CheckboxPropsCache = {};
        _this.store = createStore({
            selectedRowKeys: getRowSelection(props).selectedRowKeys || [],
            selectionDirty: false,
            customColumns: _this.state.customColumns,
            exported: false,
            exportStoreProps: undefined
        });
        return _this;
    }

    _createClass(Table, [{
        key: 'getDefaultSelection',
        value: function getDefaultSelection() {
            var _this2 = this;

            var rowSelection = getRowSelection(this.props);
            if (!rowSelection.getCheckboxProps) {
                return [];
            }
            return this.getFlatData().filter(function (item, rowIndex) {
                return _this2.getCheckboxPropsByItem(item, rowIndex).defaultChecked;
            }).map(function (record, rowIndex) {
                return _this2.getRecordKey(record, rowIndex);
            });
        }
    }, {
        key: 'getDefaultPagination',
        value: function getDefaultPagination(props) {
            var pagination = props.pagination || {};
            return this.hasPagination(props) ? _extends({}, defaultPagination, pagination, { current: pagination.defaultCurrent || pagination.current || 1, pageSize: pagination.defaultPageSize || pagination.pageSize || 10 }) : {};
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.columns = nextProps.columns || normalizeColumns(nextProps.children);
            if ('pagination' in nextProps || 'pagination' in this.props) {
                this.setState(function (previousState) {
                    var newPagination = _extends({}, defaultPagination, previousState.pagination, nextProps.pagination);
                    newPagination.current = newPagination.current || 1;
                    newPagination.pageSize = newPagination.pageSize || 10;
                    return { pagination: nextProps.pagination !== false ? newPagination : emptyObject };
                });
            }
            if (nextProps.rowSelection && 'selectedRowKeys' in nextProps.rowSelection) {
                this.store.setState({
                    selectedRowKeys: nextProps.rowSelection.selectedRowKeys || []
                });
            }
            if ('dataSource' in nextProps && nextProps.dataSource !== this.props.dataSource) {
                this.store.setState({
                    selectionDirty: false
                });
            }
            // https://github.com/ant-design/ant-design/issues/10133
            this.CheckboxPropsCache = {};
            if (this.getSortOrderColumns(this.columns).length > 0) {
                var sortState = this.getSortStateFromColumns(this.columns);
                if (sortState.sortColumn !== this.state.sortColumn || sortState.sortOrder !== this.state.sortOrder) {
                    this.setState(sortState);
                }
            }
            var filteredValueColumns = this.getFilteredValueColumns(this.columns);
            if (filteredValueColumns.length > 0) {
                var filtersFromColumns = this.getFiltersFromColumns(this.columns);
                var newFilters = _extends({}, this.state.filters);
                Object.keys(filtersFromColumns).forEach(function (key) {
                    newFilters[key] = filtersFromColumns[key];
                });
                if (this.isFiltersChanged(newFilters)) {
                    this.setState({ filters: newFilters });
                }
            }
            this.createComponents(nextProps.components, this.props.components);
        }
    }, {
        key: 'setSelectedRowKeys',
        value: function setSelectedRowKeys(selectedRowKeys, selectionInfo) {
            var _this3 = this;

            var selectWay = selectionInfo.selectWay,
                record = selectionInfo.record,
                checked = selectionInfo.checked,
                changeRowKeys = selectionInfo.changeRowKeys,
                nativeEvent = selectionInfo.nativeEvent;

            var rowSelection = getRowSelection(this.props);
            if (rowSelection && !('selectedRowKeys' in rowSelection)) {
                this.store.setState({ selectedRowKeys: selectedRowKeys });
            }
            var data = this.getFlatData();
            if (!rowSelection.onChange && !rowSelection[selectWay]) {
                return;
            }
            var selectedRows = data.filter(function (row, i) {
                return selectedRowKeys.indexOf(_this3.getRecordKey(row, i)) >= 0;
            });
            if (rowSelection.onChange) {
                rowSelection.onChange(selectedRowKeys, selectedRows);
            }
            if (selectWay === 'onSelect' && rowSelection.onSelect) {
                rowSelection.onSelect(record, checked, selectedRows, nativeEvent);
            } else if (selectWay === 'onSelectAll' && rowSelection.onSelectAll) {
                var changeRows = data.filter(function (row, i) {
                    return changeRowKeys.indexOf(_this3.getRecordKey(row, i)) >= 0;
                });
                rowSelection.onSelectAll(checked, selectedRows, changeRows);
            } else if (selectWay === 'onSelectInvert' && rowSelection.onSelectInvert) {
                rowSelection.onSelectInvert(selectedRowKeys);
            }
        }
    }, {
        key: 'hasPagination',
        value: function hasPagination(props) {
            return (props || this.props).pagination !== false;
        }
    }, {
        key: 'isFiltersChanged',
        value: function isFiltersChanged(filters) {
            var _this4 = this;

            var filtersChanged = false;
            if (Object.keys(filters).length !== Object.keys(this.state.filters).length) {
                filtersChanged = true;
            } else {
                Object.keys(filters).forEach(function (columnKey) {
                    if (filters[columnKey] !== _this4.state.filters[columnKey]) {
                        filtersChanged = true;
                    }
                });
            }
            return filtersChanged;
        }
    }, {
        key: 'getSortOrderColumns',
        value: function getSortOrderColumns(columns) {
            return flatFilter(columns || this.columns || [], function (column) {
                return 'sortOrder' in column;
            });
        }
    }, {
        key: 'getFilteredValueColumns',
        value: function getFilteredValueColumns(columns) {
            return flatFilter(columns || this.columns || [], function (column) {
                return typeof column.filteredValue !== 'undefined';
            });
        }
    }, {
        key: 'getFiltersFromColumns',
        value: function getFiltersFromColumns(columns) {
            var _this5 = this;

            var filters = {};
            this.getFilteredValueColumns(columns).forEach(function (col) {
                var colKey = _this5.getColumnKey(col);
                filters[colKey] = col.filteredValue;
            });
            return filters;
        }
    }, {
        key: 'getDefaultSortOrder',
        value: function getDefaultSortOrder(columns) {
            var definedSortState = this.getSortStateFromColumns(columns);
            var defaultSortedColumn = flatFilter(columns || [], function (column) {
                return column.defaultSortOrder != null;
            })[0];
            if (defaultSortedColumn && !definedSortState.sortColumn) {
                return {
                    sortColumn: defaultSortedColumn,
                    sortOrder: defaultSortedColumn.defaultSortOrder
                };
            }
            return definedSortState;
        }
    }, {
        key: 'getSortStateFromColumns',
        value: function getSortStateFromColumns(columns) {
            // return first column which sortOrder is not falsy
            var sortedColumn = this.getSortOrderColumns(columns).filter(function (col) {
                return col.sortOrder;
            })[0];
            if (sortedColumn) {
                return {
                    sortColumn: sortedColumn,
                    sortOrder: sortedColumn.sortOrder
                };
            }
            return {
                sortColumn: null,
                sortOrder: null
            };
        }
    }, {
        key: 'getSorterFn',
        value: function getSorterFn() {
            var _state = this.state,
                sortOrder = _state.sortOrder,
                sortColumn = _state.sortColumn;

            if (!sortOrder || !sortColumn || typeof sortColumn.sorter !== 'function') {
                return;
            }
            return function (a, b) {
                var result = sortColumn.sorter(a, b, sortOrder);
                if (result !== 0) {
                    return sortOrder === 'descend' ? -result : result;
                }
                return 0;
            };
        }
    }, {
        key: 'toggleSortOrder',
        value: function toggleSortOrder(order, column) {
            var _state2 = this.state,
                sortColumn = _state2.sortColumn,
                sortOrder = _state2.sortOrder;
            // 只同时允许一列进行排序，否则会导致排序顺序的逻辑问题

            var isSortColumn = this.isSortColumn(column);
            if (!isSortColumn) {
                // 当前列未排序
                sortOrder = order;
                sortColumn = column;
            } else {
                // 当前列已排序
                if (sortOrder === order) {
                    // 切换为未排序状态
                    sortOrder = undefined;
                    sortColumn = null;
                } else {
                    // 切换为排序状态
                    sortOrder = order;
                }
            }
            var newState = {
                sortOrder: sortOrder,
                sortColumn: sortColumn
            };
            // Controlled
            if (this.getSortOrderColumns().length === 0) {
                this.setState(newState);
            }
            var onChange = this.props.onChange;
            if (onChange) {
                onChange.apply(null, this.prepareParamsArguments(_extends({}, this.state, newState)));
            }
        }
        // 改变了原始的columns(或者更新之前添加的) modified by yang.wang06@hand-china.com

    }, {
        key: 'renderRowSelection',
        value: function renderRowSelection(columns, locale) {
            var _this6 = this;

            var _props = this.props,
                prefixCls = _props.prefixCls,
                rowSelection = _props.rowSelection;

            if (rowSelection) {
                var data = this.getFlatCurrentPageData().filter(function (item, index) {
                    if (rowSelection.getCheckboxProps) {
                        return !_this6.getCheckboxPropsByItem(item, index).disabled;
                    }
                    return true;
                });
                var selectionColumnClass = classNames(prefixCls + '-selection-column', _defineProperty({}, prefixCls + '-selection-column-custom', rowSelection.selections));
                var selectionColumn = {
                    key: 'selection-column',
                    render: this.renderSelectionBox(rowSelection.type),
                    className: selectionColumnClass,
                    fixed: rowSelection.fixed,
                    width: rowSelection.columnWidth
                };
                if (rowSelection.type !== 'radio') {
                    var checkboxAllDisabled = data.every(function (item, index) {
                        return _this6.getCheckboxPropsByItem(item, index).disabled;
                    });
                    selectionColumn.title = React.createElement(SelectionCheckboxAll, { store: this.store, locale: locale, data: data, getCheckboxPropsByItem: this.getCheckboxPropsByItem, getRecordKey: this.getRecordKey, disabled: checkboxAllDisabled, prefixCls: prefixCls, onSelect: this.handleSelectRow, selections: rowSelection.selections, hideDefaultSelections: rowSelection.hideDefaultSelections, getPopupContainer: this.getPopupContainer });
                }
                if ('fixed' in rowSelection) {
                    selectionColumn.fixed = rowSelection.fixed;
                } else if (columns.some(function (column) {
                    return column.fixed === 'left' || column.fixed === true;
                })) {
                    selectionColumn.fixed = 'left';
                }
                if (columns[0] && columns[0].key === 'selection-column') {
                    columns[0] = selectionColumn;
                } else {
                    columns.unshift(selectionColumn);
                }
            }
            return columns;
        }
    }, {
        key: 'getColumnKey',
        value: function getColumnKey(column, index) {
            return column.key || column.dataIndex || index;
        }
    }, {
        key: 'getMaxCurrent',
        value: function getMaxCurrent(total) {
            var _state$pagination = this.state.pagination,
                current = _state$pagination.current,
                pageSize = _state$pagination.pageSize;

            if ((current - 1) * pageSize >= total) {
                return Math.floor((total - 1) / pageSize) + 1;
            }
            return current;
        }
    }, {
        key: 'isSortColumn',
        value: function isSortColumn(column) {
            var sortColumn = this.state.sortColumn;

            if (!column || !sortColumn) {
                return false;
            }
            return this.getColumnKey(sortColumn) === this.getColumnKey(column);
        }
    }, {
        key: 'renderColumnsDropdown',
        value: function renderColumnsDropdown(columns, locale) {
            var _this7 = this;

            var _props2 = this.props,
                prefixCls = _props2.prefixCls,
                dropdownPrefixCls = _props2.dropdownPrefixCls;
            var sortOrder = this.state.sortOrder;

            return treeMap(columns, function (originColumn, i) {
                var column = _extends({}, originColumn);
                var key = _this7.getColumnKey(column, i);
                var filterDropdown = void 0;
                var sortButton = void 0;
                if (column.filters && column.filters.length > 0 || column.filterDropdown) {
                    var colFilters = _this7.state.filters[key] || [];
                    filterDropdown = React.createElement(FilterDropdown, { locale: locale, column: column, selectedKeys: colFilters, confirmFilter: _this7.handleFilter, prefixCls: prefixCls + '-filter', dropdownPrefixCls: dropdownPrefixCls || 'ant-dropdown', getPopupContainer: _this7.getPopupContainer });
                }
                if (column.sorter) {
                    var isSortColumn = _this7.isSortColumn(column);
                    if (isSortColumn) {
                        column.className = classNames(column.className, _defineProperty({}, prefixCls + '-column-sort', sortOrder));
                    }
                    var isAscend = isSortColumn && sortOrder === 'ascend';
                    var isDescend = isSortColumn && sortOrder === 'descend';
                    sortButton = React.createElement(
                        'div',
                        { className: prefixCls + '-column-sorter' },
                        React.createElement(
                            'span',
                            { className: prefixCls + '-column-sorter-up ' + (isAscend ? 'on' : 'off'), title: '\u2191', onClick: function onClick() {
                                    return _this7.toggleSortOrder('ascend', column);
                                } },
                            React.createElement(Icon, { type: 'caret-up' })
                        ),
                        React.createElement(
                            'span',
                            { className: prefixCls + '-column-sorter-down ' + (isDescend ? 'on' : 'off'), title: '\u2193', onClick: function onClick() {
                                    return _this7.toggleSortOrder('descend', column);
                                } },
                            React.createElement(Icon, { type: 'caret-down' })
                        )
                    );
                }
                var customButton = void 0;
                if (column.filterBar === true && _this7.props.customCode) {
                    var filterColumns = columns.filter(function (c) {
                        return c.filterField === true;
                    });
                    customButton = React.createElement(ColumnFilterMenu, { customCode: _this7.props.customCode, locale: locale, filterBarLocale: _this7.props.filterBarLocale, customColumns: _this7.getCustomColumns(), store: _this7.store, columns: filterColumns, prefixCls: prefixCls + '-filter', dropdownPrefixCls: dropdownPrefixCls || 'ant-dropdown', confirmFilter: _this7.handleCustomColumnFilter, getPopupContainer: _this7.getPopupContainer });
                }
                column.title = React.createElement(
                    'span',
                    { key: key },
                    column.title,
                    sortButton,
                    customButton,
                    filterDropdown
                );
                if (sortButton || filterDropdown || customButton) {
                    column.className = classNames(prefixCls + '-column-has-filters', column.className);
                }
                return column;
            });
        }
    }, {
        key: 'setCustomState',
        value: function setCustomState(customColumns) {
            this.setState({
                customColumns: customColumns
            });
        }
    }, {
        key: 'renderPagination',
        value: function renderPagination(paginationPosition) {
            // 强制不需要分页
            if (!this.hasPagination()) {
                return null;
            }
            var size = 'default';
            var pagination = this.state.pagination;

            if (pagination.size) {
                size = pagination.size;
            } else if (this.props.size === 'middle' || this.props.size === 'small') {
                size = 'small';
            }
            var position = pagination.position || 'bottom';
            var total = pagination.total || this.getLocalData().length;
            return total > 0 && (position === paginationPosition || position === 'both') ? React.createElement(Pagination, _extends({ key: 'pagination-' + paginationPosition }, pagination, { className: classNames(pagination.className, this.props.prefixCls + '-pagination'), onChange: this.handlePageChange, total: total, size: size, current: this.getMaxCurrent(total), onShowSizeChange: this.handleShowSizeChange })) : null;
        }
        // Get pagination, filters, sorter

    }, {
        key: 'prepareParamsArguments',
        value: function prepareParamsArguments(state) {
            var pagination = _extends({}, state.pagination);
            // remove useless handle function in Table.onChange
            delete pagination.onChange;
            delete pagination.onShowSizeChange;
            var filters = state.filters;
            var sorter = {};
            if (state.sortColumn && state.sortOrder) {
                sorter.column = state.sortColumn;
                sorter.order = state.sortOrder;
                sorter.field = state.sortColumn.dataIndex;
                sorter.columnKey = this.getColumnKey(state.sortColumn);
            }
            return [pagination, filters, sorter];
        }
    }, {
        key: 'findColumn',
        value: function findColumn(myKey) {
            var _this8 = this;

            var column = void 0;
            treeMap(this.columns, function (c) {
                if (_this8.getColumnKey(c) === myKey) {
                    column = c;
                }
            });
            return column;
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var autoHeight = this.props.autoHeight;

            if (autoHeight) {
                var tableAutoHeight = this.syncSize();
                if (this.state.tableAutoHeight !== tableAutoHeight) {
                    this.setState({ tableAutoHeight: tableAutoHeight });
                }
            }
        }
    }, {
        key: 'getCurrentPageData',
        value: function getCurrentPageData() {
            var data = this.getLocalData();
            var current = void 0;
            var pageSize = void 0;
            var state = this.state;
            // 如果没有分页的话，默认全部展示
            if (!this.hasPagination()) {
                pageSize = Number.MAX_VALUE;
                current = 1;
            } else {
                pageSize = state.pagination.pageSize;
                current = this.getMaxCurrent(state.pagination.total || data.length);
            }
            // 分页
            // ---
            // 当数据量少于等于每页数量时，直接设置数据
            // 否则进行读取分页数据
            if (data.length > pageSize || pageSize === Number.MAX_VALUE) {
                data = data.filter(function (_, i) {
                    return i >= (current - 1) * pageSize && i < current * pageSize;
                });
            }
            return data;
        }
    }, {
        key: 'getFlatData',
        value: function getFlatData() {
            return flatArray(this.getLocalData());
        }
    }, {
        key: 'getFlatCurrentPageData',
        value: function getFlatCurrentPageData() {
            return flatArray(this.getCurrentPageData());
        }
    }, {
        key: 'recursiveSort',
        value: function recursiveSort(data, sorterFn) {
            var _this9 = this;

            var _props$childrenColumn = this.props.childrenColumnName,
                childrenColumnName = _props$childrenColumn === undefined ? 'children' : _props$childrenColumn;

            return data.sort(sorterFn).map(function (item) {
                return item[childrenColumnName] ? _extends({}, item, _defineProperty({}, childrenColumnName, _this9.recursiveSort(item[childrenColumnName], sorterFn))) : item;
            });
        }
    }, {
        key: 'getLocalData',
        value: function getLocalData() {
            var _this10 = this;

            var state = this.state;
            var dataSource = this.props.dataSource;

            var data = dataSource || [];
            // 优化本地排序
            data = data.slice(0);
            var sorterFn = this.getSorterFn();
            if (sorterFn) {
                data = this.recursiveSort(data, sorterFn);
            }
            // 筛选
            if (state.filters) {
                Object.keys(state.filters).forEach(function (columnKey) {
                    var col = _this10.findColumn(columnKey);
                    if (!col) {
                        return;
                    }
                    var values = state.filters[columnKey] || [];
                    if (values.length === 0) {
                        return;
                    }
                    var onFilter = col.onFilter;
                    data = onFilter ? data.filter(function (record) {
                        return values.some(function (v) {
                            return onFilter(v, record);
                        });
                    }) : data;
                });
            }
            return data;
        }
    }, {
        key: 'createComponents',
        value: function createComponents() {
            var components = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            var prevComponents = arguments[1];

            var bodyRow = components && components.body && components.body.row;
            var preBodyRow = prevComponents && prevComponents.body && prevComponents.body.row;
            if (!this.row || bodyRow !== preBodyRow) {
                this.row = createBodyRow(bodyRow);
            }
            // modified by njq.niu@hand-china.com
            var headerProps = {};
            if (this.props.resizable) {
                headerProps.header = {
                    cell: ResizeableTitle
                };
            }
            // modified by njq.niu@hand-china.com
            this.components = _extends({}, headerProps, components, { body: _extends({}, components.body, { row: this.row }) });
        }
    }, {
        key: 'renderConfigConsumer',
        value: function renderConfigConsumer() {
            var _this11 = this;

            return function (configProps) {
                var pageProps = void 0;
                var exportedProps = _this11.props.exported;
                if (configProps.exported || exportedProps) {
                    if (configProps.exported) {
                        pageProps = _extends({}, configProps.exported);
                    }
                    if (exportedProps) {
                        // @ts-ignore
                        if (pageProps) {
                            // @ts-ignore
                            pageProps = _extends({}, pageProps, exportedProps);
                        } else {
                            pageProps = _extends({}, exportedProps);
                        }
                    }
                    // @ts-ignore
                    return _this11.renderExportButton(pageProps);
                }
                return '';
            };
        }
    }, {
        key: 'render',
        value: function render() {
            var _this12 = this;

            var _props3 = this.props,
                style = _props3.style,
                className = _props3.className,
                prefixCls = _props3.prefixCls;

            var data = this.getCurrentPageData();
            var loading = this.props.loading;
            if (typeof loading === 'boolean') {
                loading = {
                    spinning: loading
                };
            }
            var table = React.createElement(
                LocaleReceiver,
                { componentName: 'Table', defaultLocale: defaultLocale.Table },
                function (locale) {
                    return _this12.renderTable(locale, loading);
                }
            );
            // if there is no pagination or no data,
            // the height of spin should decrease by half of pagination
            var paginationPatchClass = this.hasPagination() && data && data.length !== 0 ? prefixCls + '-with-pagination' : prefixCls + '-without-pagination';
            return React.createElement(
                'div',
                { className: classNames(prefixCls + '-wrapper', className), ref: this.setWapperRef, style: style },
                React.createElement(
                    Spin,
                    _extends({}, loading, { className: loading.spinning ? paginationPatchClass + ' ' + prefixCls + '-spin-holder' : '' }),
                    this.renderPagination('top'),
                    table,
                    this.renderPagination('bottom')
                )
            );
        }
    }]);

    return Table;
}(React.Component);

export default Table;

Table.TableRowContext = TableRowContext; // modified by njq.niu@hand-china.com
Table.Column = Column;
Table.ColumnGroup = ColumnGroup;
Table.propTypes = {
    dataSource: PropTypes.array,
    columns: PropTypes.array,
    prefixCls: PropTypes.string,
    useFixedHeader: PropTypes.bool,
    resizable: PropTypes.bool,
    rowSelection: PropTypes.object,
    className: PropTypes.string,
    size: PropTypes.string,
    loading: PropTypes.oneOfType([PropTypes.bool, PropTypes.object]),
    bordered: PropTypes.bool,
    onChange: PropTypes.func,
    locale: PropTypes.object,
    dropdownPrefixCls: PropTypes.string,
    exported: PropTypes.object,
    autoHeight: PropTypes.oneOfType([PropTypes.bool, PropTypes.object])
};
Table.defaultProps = {
    dataSource: [],
    prefixCls: 'ant-table',
    useFixedHeader: false,
    className: '',
    size: 'default',
    loading: false,
    bordered: false,
    resizable: true,
    indentSize: 20,
    locale: {},
    rowKey: 'key',
    showHeader: true,
    autoHeight: false
};