import * as React from 'react';
import { UploadListProps, UploadFile, UploadListType } from './interface';
import '../icon/style';
import '../tooltip/style';
import '../popconfirm/style';
import '../progress/style';
export default class UploadList extends React.Component<UploadListProps, any> {
    static defaultProps: {
        listType: UploadListType;
        progressAttr: {
            strokeWidth: number;
            showInfo: boolean;
        };
        prefixCls: string;
        showRemoveIcon: boolean;
        showPreviewIcon: boolean;
        showDownloadIcon: boolean;
        showReUploadIcon: boolean;
    };
    handleClose: (file: UploadFile) => void;
    handlePreview: (file: UploadFile, e: React.SyntheticEvent<HTMLElement>) => void;
    /**
     * modified by yang.wang06@hand-china.com
     * @param {UploadFile} file
     * @param {React.SyntheticEvent<HTMLElement>} e
     */
    handleReUpload: (file: UploadFile, e: React.SyntheticEvent<HTMLElement>) => boolean | void;
    componentDidUpdate(): void;
    render(): JSX.Element;
}
